=== debian/changelog ===
libsbml (5.6.0-1) unstable; urgency=low

  [ Ivo Maintz ]
  * update from upstream
  * configured now with --enable-cpp-namespace

 -- Ivo Maintz <ivo@maintz.de>  Thu, 06 Sep 2012 09:21:33 +0200

libsbml (5.4.1-4) UNRELEASED; urgency=low

  [ Steffen ]
  * Removed everyone from Uploaders except Ivo
    - Ivo also builds the libsbml5-matlab package, the 
      control file is changed dynamically when the Matlab
      development environment is detected.
    - Matlab creator Mathworks provides their development
      package to help us. 

  [ Andreas Tille ]
  * debian/upstream: Make author field BibTeX compliant

 -- Steffen <moeller@debian.org>  Tue, 10 Apr 2012 13:50:44 +0200
