=== debian/watch ===
version=3
http://sf.net/sbml/  lib[Ss][Bb][Mm][Ll]-(.*)-src\.tar\.gz
